package com.example.bluetooth_dcmot_servo;


import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Method;
import java.util.UUID;
import android.app.Activity;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.bluetooth.BluetoothSocket;
import android.content.Context;
import android.content.Intent;
import android.hardware.Sensor;
import android.hardware.SensorEvent;
import android.hardware.SensorEventListener;
import android.hardware.SensorManager;
import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.CompoundButton;
import android.widget.TextView;
import android.widget.Toast;
import android.widget.ToggleButton;
  
public class MainActivity extends Activity implements SensorEventListener,OnClickListener {
  private static final String TAG = "bluetoothDC";
    
  TextView tvakku_motor,tvakku_uC,tvcurrent_motor;
  private ConnectedThread mConnectedThread; 
  Handler h; 
  SensorManager sm;
  Sensor s;
  float sensorX,sensorY,sensorZ,deltaX,deltaY,prev_sensorX,prev_sensorY,prev_sensorZ;
  double prev_szogX,prev_szogY,prev_szogZ;
  double szogX,szogY,szogZ;
  double XYZ;
  int db=0;
  int treshold = 100;
  int szog_treshold =3; 
  boolean first = true;
  boolean isGO 	= false;
 
  private BluetoothAdapter btAdapter = null;
  private BluetoothSocket btSocket = null;
  private OutputStream outStream = null;
  private StringBuilder sb = new StringBuilder();
  final int RECIEVE_MESSAGE = 1;
  CheckBox cb_pc0,cb_pc1,cb_pc2;
  
  ToggleButton tb_Go,tb_lampaL,tb_lampaR;
  Button bSTOP;
  
  // SPP UUID service
  private static final UUID MY_UUID = UUID.fromString("00001101-0000-1000-8000-00805F9B34FB");
  
  // a Bt MAC cme, ezt mdostani kell a konkrt BT cmre  
  private static String address ="00:06:66:63:CC:F2";
    
  /** Called when the activity is first created. */
  @Override
  public void onCreate(Bundle savedInstanceState) {
    super.onCreate(savedInstanceState);
    setContentView(R.layout.activity_main);  
    tvakku_uC = (TextView) findViewById(R.id.tvakku_uC);
    tvakku_motor = (TextView) findViewById(R.id.tvakku_motor);
    tvcurrent_motor = (TextView) findViewById(R.id.tvcurrent_motor);
    sm = (SensorManager)getSystemService(Context.SENSOR_SERVICE);
    if(sm.getSensorList(Sensor.TYPE_ACCELEROMETER).size() !=0){
    	s =	sm.getSensorList(Sensor.TYPE_ACCELEROMETER).get(0); 
    }
    cb_pc0=(CheckBox)findViewById(R.id.PC0);
    cb_pc1=(CheckBox)findViewById(R.id.PC1);
    cb_pc2=(CheckBox)findViewById(R.id.PC2);
    tb_Go=(ToggleButton)findViewById(R.id.tbGo);
    tb_lampaL=(ToggleButton)findViewById(R.id.tb_lampaL);
    tb_lampaR=(ToggleButton)findViewById(R.id.tb_lampaR);
    tb_Go.setText(null); tb_Go.setTextOn(null); tb_Go.setTextOff(null);
    tb_lampaL.setText(null); tb_lampaL.setTextOn(null); tb_lampaL.setTextOff(null);
    tb_lampaR.setText(null); tb_lampaR.setTextOn(null); tb_lampaR.setTextOff(null);
    bSTOP=(Button)findViewById(R.id.bSTOP);
    class myCheckBoxChnageClicker implements CheckBox.OnCheckedChangeListener
	 {
    	
		@Override
		public void onCheckedChanged(CompoundButton buttonView, boolean isChecked) {
			// TODO Auto-generated method stub
					
			if((buttonView==cb_pc0)||(buttonView==cb_pc1)||(buttonView==cb_pc2)){
				int num = 0;
				if(cb_pc0.isChecked()){num++;}
				if(cb_pc1.isChecked()){num+=2;}
				if(cb_pc2.isChecked()){num+=4;}
				sendData("#DAC"+num+",");
			}
		}
	 }
    
   
    cb_pc0.setOnCheckedChangeListener(new myCheckBoxChnageClicker());
    cb_pc1.setOnCheckedChangeListener(new myCheckBoxChnageClicker());
    cb_pc2.setOnCheckedChangeListener(new myCheckBoxChnageClicker());
   
    class mysetOnClickListener implements ToggleButton.OnCheckedChangeListener{

		@Override
		public void onCheckedChanged(CompoundButton buttonView,
				boolean isChecked) {
			if(buttonView==tb_Go){
				if(isChecked)
				{
					isGO=true;
					sendData("#ON,");
				}else
				{
					sendData("#STOP,");	
					isGO=false;
				}	
		    }
			if((buttonView==tb_lampaL) || (buttonView==tb_lampaR)){
				byte b=0;
				if(tb_lampaL.isChecked()) {b++;}
				if(tb_lampaR.isChecked()) {b+=2;}
				sendData("#LA"+b+",");
			} 
		}
    }
    	
    tb_Go.setOnCheckedChangeListener(new mysetOnClickListener());
    tb_lampaL.setOnCheckedChangeListener(new mysetOnClickListener());
    tb_lampaR.setOnCheckedChangeListener(new mysetOnClickListener());
    bSTOP.setOnClickListener(this);
     
    h = new Handler() {
    	public void handleMessage(android.os.Message msg) {
    		int myNum=0;
    		switch (msg.what) {
            case RECIEVE_MESSAGE:													// if receive massage
            	byte[] readBuf = (byte[]) msg.obj;
            	String strIncom = new String(readBuf, 0, msg.arg1);					// create string from bytes array
            	sb.append(strIncom);												// append string
            	int endOfLineIndex = sb.indexOf("\r\n");							// determine the end-of-line
            	if (endOfLineIndex > 0) { 											// if end-of-line,
            		String sbprint = sb.substring(0, endOfLineIndex),sb2;				// extract string
            		sb.delete(0, sb.length());										// and clear
            		if(sbprint.contains("#AKKU_UC;")){
            			sb2=sbprint.substring(9, sbprint.length());
            			try {
            			    myNum = Integer.parseInt(sb2);
            			} catch(NumberFormatException nfe) {
            			   
            			} 
            			tvakku_uC.setText(" U uC:"+Math.round(myNum*17.7591)+" mV");
            		} else 
            		if(sbprint.contains("#AKKU_MOTOR;")){
            			sb2=sbprint.substring(12, sbprint.length());
            			try {
                		    myNum = Integer.parseInt(sb2);
                		} catch(NumberFormatException nfe) {
                		   
                		}
            			tvakku_motor.setText(" U motor:"+Math.round(myNum*17.5758)+" mV");
                	} else 
                		if(sbprint.contains("#CURR_MOT;")){
                			sb2=sbprint.substring(10, sbprint.length());
                			try {
                    		    myNum = Integer.parseInt(sb2);
                    		} catch(NumberFormatException nfe) {
                    		   
                    		}
                			tvcurrent_motor.setText(" I motor:"+Math.round(myNum*10.618)+" mA");
                    	}
                }
            	Log.d(TAG, "...String:"+ myNum +  "Byte:" + msg.arg1 + "...");
            	break;
    		}
        }
		
	}; 
    btAdapter = BluetoothAdapter.getDefaultAdapter();
    checkBTState();
  }
   
 
  private BluetoothSocket createBluetoothSocket(BluetoothDevice device) throws IOException {
      if(Build.VERSION.SDK_INT >= 10){
          try {
              final Method  m = device.getClass().getMethod("createInsecureRfcommSocketToServiceRecord", new Class[] { UUID.class });
              return (BluetoothSocket) m.invoke(device, MY_UUID);
          } catch (Exception e) {
              Log.e(TAG, "Could not create Insecure RFComm Connection",e);
          }
      }
      return  device.createRfcommSocketToServiceRecord(MY_UUID);
  }
    
  @Override
  public void onResume() {
    super.onResume();
    sm.registerListener(this, s, SensorManager.SENSOR_DELAY_NORMAL); 		//161ms-ek
    Log.d(TAG, "...onResume - try connect...");
    
    // Set up a pointer to the remote node using it's address.
    BluetoothDevice device = btAdapter.getRemoteDevice(address);
    
        
    try {
        btSocket = createBluetoothSocket(device);
    } catch (IOException e1) {
        errorExit("Fatal Error", "In onResume() and socket create failed: " + e1.getMessage() + ".");
    }
        
    // A BT keresse erforrs intenzv dolog, emiatt ki kell kapcsolni ezt a funkcit.  
    btAdapter.cancelDiscovery();
    
    // A kapcsolat ltrehozsa
    Log.d(TAG, "...Connecting...");
    try {
      btSocket.connect();
      Log.d(TAG, "...Connection ok...");
    } catch (IOException e) {
      try {
        btSocket.close();
      } catch (IOException e2) {
        errorExit("Fatal Error", "In onResume() and unable to close socket during connection failure" + e2.getMessage() + ".");
      }
      
    }
      
    // stream ltrehozsa
    Log.d(TAG, "...Create Socket...");
  
    try {
      outStream = btSocket.getOutputStream();
    } catch (IOException e) {
      errorExit("Fatal Error", "In onResume() and output stream creation failed:" + e.getMessage() + ".");
    }
    mConnectedThread = new ConnectedThread(btSocket);
    mConnectedThread.start(); 
    first=true;
  }
  
  @Override
  public void onPause() {
	  sm.unregisterListener(this);
	  super.onPause();
  
    Log.d(TAG, "...In onPause()...");
  
    if (outStream != null) {
      try {
        outStream.flush();
      } catch (IOException e) {
        errorExit("Fatal Error", "In onPause() and failed to flush output stream: " + e.getMessage() + ".");
      }
    }
  
    try     {
      btSocket.close();
    } catch (IOException e2) {
      errorExit("Fatal Error", "In onPause() and failed to close socket." + e2.getMessage() + ".");
    }
  }
    
  private void checkBTState() {
    // Ellenrizzk van-e a kszlkben BT egysg
    if(btAdapter==null) {
      errorExit("Fatal Error", "Bluetooth not support");
    } else {
      if (btAdapter.isEnabled()) {
        Log.d(TAG, "...Bluetooth ON...");
      } else {
        //Ha van, de nincs bekapcsolva, akkor a kpernyre kiratjuk 
        Intent enableBtIntent = new Intent(BluetoothAdapter.ACTION_REQUEST_ENABLE);
        startActivityForResult(enableBtIntent, 1);
      }
    }
  }
  
  private void errorExit(String title, String message){
    Toast.makeText(getBaseContext(), title + " - " + message, Toast.LENGTH_LONG).show();
    finish();
  }
  
  private void sendData(String message) {
    
      mConnectedThread.write(message);
}

private class ConnectedThread extends Thread {
    private final InputStream mmInStream;
    private final OutputStream mmOutStream;
 
    public ConnectedThread(BluetoothSocket socket) {
        InputStream tmpIn = null;
        OutputStream tmpOut = null;
 
        
        try {
            tmpIn = socket.getInputStream();
            tmpOut = socket.getOutputStream();
        } catch (IOException e) { }
 
        mmInStream = tmpIn;
        mmOutStream = tmpOut;
    }
 
    public void run() {
        byte[] buffer = new byte[256];  
        int bytes; 

        while (true) {
        	try {
                // Olvass az InputStream-bl
                bytes = mmInStream.read(buffer);		
                h.obtainMessage(RECIEVE_MESSAGE, bytes, -1, buffer).sendToTarget();		
            } catch (IOException e) {
                break;
            }
        }
    }
 
    
    public void write(String message) {
    	Log.d(TAG, "...Data to send: " + message + "...");
    	byte[] msgBuffer = message.getBytes();
    	try {
            mmOutStream.write(msgBuffer);
        } catch (IOException e) {
            Log.d(TAG, "...Error data send: " + e.getMessage() + "...");     
          }
    }
}

@Override
public void onAccuracyChanged(Sensor sensor, int accuracy) {
	// TODO Auto-generated method stub
	
}

@Override
public void onSensorChanged(SensorEvent event) {
	long szam=0;
	// TODO Auto-generated method stub
		sensorX=100*event.values[0];
		sensorY=100*event.values[1];
		sensorZ=100*event.values[2];
		XYZ=Math.sqrt(event.values[0]*event.values[0]+event.values[1]*event.values[1]+event.values[2]*event.values[2]);
		szogX=(180/Math.PI)*Math.acos(event.values[0]/XYZ);
		szogY=(180/Math.PI)*Math.acos(event.values[1]/XYZ);
		szogZ=(180/Math.PI)*Math.acos(event.values[2]/XYZ);
		if(first){
			prev_sensorX=sensorX;
			prev_sensorY=sensorY;
			prev_sensorZ=sensorZ;
			prev_szogX=szogX;
			prev_szogY=szogY;
			prev_szogZ=szogZ;
			first=false;
		}
		db++;
		if((db%9)==0){
			sendData("#I_MO,");	// Motor ram
		}
		if(db == 26){
			sendData("#A_MO,"); //motor akkumultor adat
		}
		if(db == 42){
			sendData("#A_UC,");	//uC akkumultor adat
			db=0;
		}
		if(isGO){
			if(((szogX-prev_szogX)>szog_treshold) || ((szogX-prev_szogX)<-szog_treshold)) {
				prev_szogX=szogX;
				
			}	
			if(((szogY-prev_szogY)>szog_treshold) || ((szogY-prev_szogY)<-szog_treshold)) {
				prev_szogY=szogY;
				
				if((szogY <= 95) && (szogY >= 85)){		// ha ebbe a svba esik, akkor stop
					
					Log.d(TAG,"#SS,");
				}	
				if(szogY > 95){		//balra tekertem
					szam=Math.round((szogY-95)*100/85);
					sendData("#SL"+szam+",");
					
				}		
				if(szogY < 85){ 	//jobbra tekertem
					szam=Math.round((85-szogY)*100/85);
					sendData("#SR"+szam+",");
					
				}	
					
			}	
			if(((szogZ-prev_szogZ)>szog_treshold) || ((szogZ-prev_szogZ)<-szog_treshold)) {
				prev_szogZ=szogZ;
				
				if((szogZ<=95) && (szogZ >=85)){		// ha ebbe a svba esik, akkor stop
					sendData("#MS,");	
					
				}	
				if(szogZ > 95){		//htra tekertem
					szam=Math.round((szogZ-95)*100/85);
					sendData("#MR"+szam+",");
					
				}		
				if(szogZ < 85){ 	//elre tekertem
					szam=Math.round((85-szogZ)*100/85);
					sendData("#MF"+szam+",");
					
				}	
			}	
		}
	}


@Override
public void onClick(View v) {
	// TODO Auto-generated method stub
	switch(v.getId()) {
    case R.id.bSTOP:
    	sendData("#STOP,");	
    	tb_Go.setChecked(false);
      break;
  }
}




}
    
